<?php

 /* This script will connect to the SolusVM instance running on each slave server listed. 
 
 
 Instructions:
 
 Place this file on your SolusVM master control panel server in /usr/local/solusvm/www and set the ownership and group to solusvm (e.g. chown solusvm:solusvm solusvm_check.php)
 
 Update the $key variable to a random key and update the $servers variable to a list of your SolusVM slave servers.
 
 Create a new check on your ServerPing instance and set the check type to HTTPS Custom Script.
 Enter the url to this script on your control panel and pass the random key you selected. 
 e.g https://controlpanel.yourdomain.com:5656/solusvm_check.php?key=randomkeyhere
 Set the timeout to 30 seconds since it may take a few seconds to check all of the slave servers depending on how many you have.
 Select your notification list and click save.
 
 */



 $key = "randomkeyhere";
 $servers = array("server1.yourdomain.com","server2.yourdomain.com","server3.yourdomain.com");
 
 
 
 if ($_GET['key'] == $key ) {
  
   $mtime = microtime();
   $mtime = explode(" ",$mtime);
   $mtime = $mtime[1] + $mtime[0];
   $start_time = $mtime;
   
   $error = "";
   $pass = true;
   foreach($servers as $server) {
     $node_error = check_node($server);
     if ($node_error != "") {
       $pass = false;
       $error = $error . $node_error;
     }
   
   }
   
   $mtime = microtime();
   $mtime = explode(" ",$mtime);
   $mtime = $mtime[1] + $mtime[0];
   $end_time = $mtime;
   $response_time = round(($end_time - $start_time), 3);

   $results = array("result" => $pass, "error_message" =>$error, "response_time" => $response_time);
   echo json_encode($results);
   
}

function check_node($node_name) {
  $ch = curl_init();
  curl_setopt($ch, CURLOPT_URL, "https://" . $node_name . "/command.php");
  curl_setopt($ch, CURLOPT_PORT, 6767);
  curl_setopt($ch, CURLOPT_TIMEOUT, 8);
  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
  $data = curl_exec($ch);  
  curl_close($ch);
  
  if ($data == false) {
   return "Unable to connect to SolusVM on $node_name, this could indicate the server is down. Please check on $node_name ASAP!";
  }
  else {
    return "";
  }
}

?>